/*
 * Copyright (c) 2017 comsuisse AG
 *
 * SPDX-License-Identifier: Apache-2.0
 */

//#include <zephyr.h>
/*
#include <zephyr/types.h>
#include <zephyr/settings/settings.h>
#include <zephyr/kernel/stats.h>
#include  <stdio.h>
#include <string.h>
#include "common.h"
#include <zephyr/drivers/gpio.h>
*/
#include <stdio.h>
#include <stddef.h>
//#include <zephyr/drivers/sensor.h>
#include <zephyr/types.h>
//#include <zephyr/kernel.h>
#include <zephyr/device.h>
#include <soc.h>
#include <zephyr/bluetooth/bluetooth.h>
#include <zephyr/bluetooth/uuid.h>
#include <zephyr/bluetooth/gatt.h>
#include <zephyr/bluetooth/hci.h>

#include <bluetooth/services/nus.h>

#include <zephyr/drivers/gpio.h>

#include <zephyr/settings/settings.h>
#include <zephyr/pm/pm.h>
#include <zephyr/pm/device.h>
#include <zephyr/pm/policy.h>
#include <stdio.h>
#include "common.h"
extern const struct device *gpio0;  
extern const struct device *gpio1;
extern k_tid_t CURRENT_THREAD;
extern bool KEYPADACTIVE;   
extern bool DOORACTIVE; 
extern bool HASPACTIVE; 
extern bool TIMER_RUNNING;
extern bool RFALALARM;
extern bool TESTING;
extern bool CONNECTED;
extern uint32_t KEYPAD_REACTIVATE;
uint32_t RFALINTTIME;
volatile extern int MILLITIME; 
extern struct k_timer msclock;  
extern struct gpio_callback keypad_cb_data_gpio0; 
extern struct gpio_callback keypad_cb_data_gpio1;

struct gpio_callback rfal_cb_data; 

void st25r3916Isr();                                             // cast to establish the rfal callback


void key_pressed_gpio0(const struct device *dev, struct gpio_callback *cb,
		    uint32_t pins)
{                                                                    
        if(CONNECTED)                                                           // the keypad is deatcivted when we're connected to bluetooth
            return;
   
        
        if(!TESTING)
        {
            KEYPADACTIVE=true;
            k_wakeup(CURRENT_THREAD);   
        }                                             
}

void key_pressed_gpio1(const struct device *dev, struct gpio_callback *cb,
		    uint32_t pins)
{          
        if(CONNECTED)                                                            // the keypad is deatcivted when we're connected to bluetooth
            return;                                                      
       if(!TESTING)
       {
           KEYPADACTIVE=true;
           k_wakeup(CURRENT_THREAD);    
       }                                          
}
 
void init_gpio()
{       int ret;
 	gpio0 =DEVICE_DT_GET(DT_NODELABEL(gpio0));
        if(gpio0==NULL)
            {//printk("GPIO OPEN FAILED\n");
             return;
             }
    gpio1 =DEVICE_DT_GET(DT_NODELABEL(gpio1));
        if(gpio1==NULL)
            {//printk("GPIO OPEN FAILED\n");
             return;
             }
        ret = gpio_pin_configure(gpio0, COL1,GPIO_OUTPUT_LOW);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0, COL2, GPIO_OUTPUT_LOW);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0, COL3, GPIO_OUTPUT_LOW);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0, LED_GREEN, GPIO_OUTPUT_LOW);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0, LED_RED, GPIO_OUTPUT_LOW);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0, LED_ILLUM, GPIO_OUTPUT_LOW);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0, ROW1, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;      
        ret = gpio_pin_configure(gpio0, ROW2, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0, ROW3, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;      
        ret = gpio_pin_configure(gpio1, ROW4, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;  
        ret = gpio_pin_interrupt_configure(gpio0,ROW1,GPIO_INT_EDGE_RISING | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;
        ret = gpio_pin_interrupt_configure(gpio0,ROW2,GPIO_INT_EDGE_RISING | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return; 
        ret = gpio_pin_interrupt_configure(gpio0,ROW3,GPIO_INT_EDGE_RISING | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return; 
        ret = gpio_pin_interrupt_configure(gpio1,ROW4,GPIO_INT_EDGE_RISING | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return; 
        gpio_init_callback(&keypad_cb_data_gpio0, key_pressed_gpio0, BIT(ROW1) |
                                                            BIT(ROW2) |
                                                            BIT(ROW3));
        gpio_init_callback(&keypad_cb_data_gpio1, key_pressed_gpio1, BIT(ROW4));                                                   
   
        ret=gpio_add_callback(gpio0, &keypad_cb_data_gpio0);
        if (ret != 0) 
                return;
        ret=gpio_add_callback(gpio1, &keypad_cb_data_gpio1);
        if (ret != 0) 
                return;


        ret = gpio_pin_configure(gpio1, PIN_ADCENABLE, GPIO_OUTPUT_LOW);
        if (ret != 0)
           	return;
 
        ret = gpio_pin_configure(gpio0, PIN_M1, GPIO_OUTPUT_LOW);
        if (ret != 0)
           	return;
        ret = gpio_pin_configure(gpio0, PIN_M2, GPIO_OUTPUT_LOW);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio1, PIN_M3, GPIO_OUTPUT_LOW);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio0, PIN_M4, GPIO_OUTPUT_LOW);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio1, VDD2_ENABLE, GPIO_OUTPUT_LOW);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio0, VDD3_ENABLE, GPIO_OUTPUT_LOW);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio0, VDD5_ENABLE, GPIO_OUTPUT_LOW);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio0, Q_PON, GPIO_DISCONNECTED);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio1, Q_PWRKEY, GPIO_OUTPUT_LOW);
        if (ret != 0) 
           	return;
        ret = gpio_pin_configure(gpio0, Q_STATUS,GPIO_DISCONNECTED);
        if (ret != 0)    
            return;  
        ret = gpio_pin_configure(gpio0,HASPSW, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;           
        ret = gpio_pin_configure(gpio0, DOORSW, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;
        ret = gpio_pin_configure(gpio0, CNTRSW, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;
        ret = gpio_pin_configure(gpio0, RFIRQ, GPIO_INPUT |  GPIO_PULL_DOWN | GPIO_ACTIVE_HIGH);
        if (ret != 0)    
            return;

 
                                   
   







        gpio_pin_set(gpio1,VDD2_ENABLE,0);                          // SET OUTPUT PINS LOW
        gpio_pin_set(gpio0,VDD3_ENABLE,0);
        gpio_pin_set(gpio0,VDD5_ENABLE,0);
        gpio_pin_set(gpio1,Q_PWRKEY,0);
        gpio_pin_set(gpio0,COL1,0);
        gpio_pin_set(gpio0,COL2,0);
        gpio_pin_set(gpio0,COL3,0);
        gpio_pin_set(gpio0,LED_GREEN,0);
        gpio_pin_set(gpio0,LED_ILLUM,0);
        gpio_pin_set(gpio0,LED_RED,0);
        gpio_pin_set(gpio0,PIN_M1,0);
        gpio_pin_set(gpio0,PIN_M2,0);
        gpio_pin_set(gpio1,PIN_M3,0);
        gpio_pin_set(gpio0,PIN_M4,0);
        gpio_pin_set(gpio1,PIN_ADCENABLE,0);
       
}

void keypadsetup()                                                              // prepares the keypad for data entry
{       uint32_t ret;

        gpio_pin_set(gpio0,COL1,0);                                             // set thecolumn GPIO ports low
        gpio_pin_set(gpio0,COL2,0);
        gpio_pin_set(gpio0,COL3,0);
        MILLITIME=0;                                                            // reset the millisecond timer
        k_timer_start(&msclock, K_MSEC(1), K_MSEC(1));                          // and start it up
        TIMER_RUNNING=true;                                                     // set the timer running switch (used in lock commmand)
        ret=gpio_remove_callback(gpio0, &keypad_cb_data_gpio0);                 // disable the keypad callback on gpio0        
        ret=gpio_remove_callback(gpio1, &keypad_cb_data_gpio1);                 // disable the keypad callback on gpio1

        return;
 }
void setup_keyscan()                                                            // resets the keypad to it's initial set - a key depression will trigger the keypad routine
{    uint32_t ret;

        ret =  gpio_pin_set(gpio0, COL1, 1);
        ret =  gpio_pin_set(gpio0, COL2, 1);
        ret =  gpio_pin_set(gpio0, COL3, 1);
        KEYPADACTIVE = false;
        ret=gpio_add_callback(gpio0, &keypad_cb_data_gpio0);
        ret=gpio_add_callback(gpio1, &keypad_cb_data_gpio1);
}         
