// The error log contains exception messages genenerated by the firmware for excpetion conditions that
// have occurred during program execution. Ideally, there will be none of these - but I am including the
// moduke primarily to monitor performancw.
// These messages will reside in EEPROM - the starting address is pointed to by the EEPROM  MAP which
// is initialialized in main()
// The messages are in the form of a ring buffer whose beginning is at MSGS.fstmsg, whose end is at MSGS.lstmsg
// and whose length is determined by MSGS.availcnt



#include <zephyr/kernel.h>
#include  <stdio.h>
#include <string.h>
#include "common.h"

extern struct EEPROMMAP MAP;
struct EEPROMMSGS MSGS;
struct LOGMSG logmsg;  
extern bool LOGGING; 
extern bool VDD2_UP;
uint32_t LOGADDR;
uint32_t MSGSADDR;
void logmsg_delx(struct EEPROMMSGS *msgs)                            // delete the oldest message routine. Note that this assumes that the MSGS
{        
    uint8_t buffer[20];                                              // structure is already in memory
     if((msgs->fstmsg==9999)&&(msgs->lstmsg==9999))
        {
            bt_send_data("NOTHING TO DELETE");
            return;
        }
    LOGGING=true;
    sprintf(buffer,"DELETED %d",msgs->fstmsg);
     bt_send_data(buffer);
     msgs->fstmsg++;                                                  // we simply move the first message pointer to the next available slot
     if(msgs->fstmsg>(msgs->availcnt-1))                               // if we overflowed
        msgs->fstmsg=0;                                               //    move back to the beginning of the ring buffer
     msgs->msgcnt--;                                                  // decrement the message count
     if(msgs->msgcnt==0)                                              // if this was the only message in the buffer
         {
             msgs->fstmsg=9999;                                       // flag the ringbuffer as emoty
             msgs->lstmsg=9999;
             bt_send_data("DELETED LAST");
         }                                                                
    LOGGING=false;                                                            // note that we don't epdate the EEPROM with the new pointers
}
void logmsg_add(uint32_t msgpool, uint8_t *data)                     // message pool points to the message que being added to
                                                                     //    0 is the LOG FILE
                                                                     //    1 is the ACTIVITY FILE
                                                                     //    2 is the MESSAGE FILE
{struct LOGMSG msg;
struct RTCDATE date;
uint32_t i, nextmsg,pool;
uint8_t buffer[100],buffer2[100];
 LOGGING=true;                                                        // set the 'I'm logging' flag memset(&msg,0,sizeof(msg));                                          // clear the record to nulls
 if(msgpool!=1)                                                       // if this is a text message
     {
      date=get_rtc();                                                      // get the current date and time
      msg.date=dt_to_posix(date);                                          // store it as a posix date   
      strcpy(msg.data,data);                                                // copy in he messagee text
     }
 else   memmove(&msg,data,32);                                         // if this is an activity record, simply copy it
 pool=msgpool;                                                        // just so I can se it in the debugger
 sprintf(buffer,"POOL %d",pool);
 LOGADDR=MAP.addr[10+pool];                                           // get the address of the messages pointer

 MSGSADDR=LOGADDR+sizeof(MSGS);                                       // calcukate the messages base address
 eeprom_retrieve(LOGADDR, sizeof(MSGS),&MSGS);                        // reterieve the messages pointers
 if(VDD2_UP)
     strcpy(buffer2,"UP");
 else strcpy(buffer2,"DOWN");
 sprintf(buffer,"(1)LOGADDR %d SIZE %d FST %d LST %d CNT %d AVAIL %d VDD2 %s",LOGADDR,sizeof(MSGS),MSGS.fstmsg,MSGS.lstmsg,MSGS.msgcnt,MSGS.availcnt,buffer2);                         
 bt_send_data(buffer);
 if(MSGS.msgcnt==MSGS.availcnt)                                       // if the ring buffer is full
     {for(i=0;i<20;i++)                                               //     delete the oldest 20 messages
        logmsg_delx(&MSGS);                                           //    
    } 
 if(MSGS.fstmsg==9999)                                                // If the ring buffer is empty
     {
        MSGS.fstmsg=0;                                                //   point at the beginning of the buffer
        MSGS.lstmsg=-1;                                               //   this is et to -1 so the nextmsg calcullation will work
     }

 if(MSGS.lstmsg==(MSGS.availcnt-1))                                   // If the next message would overflow the ring buffer
     nextmsg=0;                                                       // point back to the beginning of the ring buffer
 else nextmsg=MSGS.lstmsg+1;                                          //      otherwise, just point to tne next seeprom
 eeprom_store(MSGSADDR+nextmsg*sizeof(msg),sizeof(msg),&msg);         // noiw - store the message in EEPROM
 MSGS.lstmsg=nextmsg;                                                 // update the pointers
 MSGS.msgcnt++;
 if(VDD2_UP)
 strcpy(buffer2,"UP");
else strcpy(buffer2,"DOWN");
sprintf(buffer,"(2)LOGADDR %d SIZE %d FST %d LST %d CNT %d AVAIL %d VDD2 %s",LOGADDR,sizeof(MSGS),MSGS.fstmsg,MSGS.lstmsg,MSGS.msgcnt,MSGS.availcnt,buffer2);                         
bt_send_data(buffer);
eeprom_store(LOGADDR,sizeof(MSGS),&MSGS);                            // and restore the pointers to EEPROM
LOGGING=false;                                                        // reset the 'I'm logging' flag  
}

void logmsg_del(uint32_t pool)
{
struct EEPROMMSGS MSGS;


uint32_t LOGADDR;
uint32_t MSGSADDR;
LOGGING=true;                                                        // set the 'I'm logging' flag
LOGADDR=MAP.addr[10+pool];                                           // get the address of the messages pointer
MSGSADDR=LOGADDR+sizeof(MSGS);                                       // calcukate the messages base address
eeprom_retrieve(LOGADDR, sizeof(MSGS),&MSGS);                        // reterieve the messages pointers
LOGADDR=MAP.addr[10+pool];                                            // get the address of the messages pointer
MSGSADDR=LOGADDR+sizeof(MSGS);                                       // calcukate the messages base address
eeprom_retrieve(LOGADDR, sizeof(MSGS),&MSGS);                        // retrieve the pointers
logmsg_delx(&MSGS);                                                  // otherwise delete one message
eeprom_store(LOGADDR,sizeof(MSGS),&MSGS);                            //      restore the pointers to EEPROM
LOGGING=false;                                                        // reset the 'I'm logging' flag  
return;                                                            // and return a 0
}
 uint32_t msg_cnt(uint32_t pool)                                     // returns the number of messages in the pool

 {
  uint32_t LOGADDR;
  uint32_t MSGSADDR;
  LOGADDR=MAP.addr[10+pool];                                            // get the address of the messages pointer
  MSGSADDR=LOGADDR+sizeof(MSGS);                                       // calcukate the messages base address
  eeprom_retrieve(LOGADDR, sizeof(MSGS),&MSGS);                        // retrieve the pointers
  return(MSGS.msgcnt);                                                 // and retrurn the message count
 }
 struct LOGMSG * retrieve_msg(uint32_t pool, uint32_t msgnbr)           // return a pointer to a given message number in a given pool
 {
    
  uint32_t LOGADDR;
  uint32_t address;
  uint32_t maddress;


  static struct LOGMSG msg;
  LOGADDR=MAP.addr[10+pool];                                            // get the address of the messages pointer
  eeprom_retrieve(LOGADDR, sizeof(MSGS),&MSGS);                        // retrieve the pointers
  if(msgnbr>MSGS.msgcnt)                                               // if the nessage requested does not exist
       return NULL;                                                    // return a NULL pointer
  address=MSGS.fstmsg+msgnbr;                                          // calculate the absolute eeprom address of the message - first adding the requested message number 
  if(address>=MSGS.availcnt)                                           // to the first message number. if the resut is beyond the pool 
       address-=MSGS.availcnt;                                         //       we-ve wrapped aroun the end
  maddress=LOGADDR+sizeof(MSGS)+address*sizeof(msg);
  eeprom_retrieve(maddress,sizeof(msg),&msg);
  return &msg;                                                
  
 }
