/*
 * Copyright (c) 2017 comsuisse AG
 *
 * SPDX-License-Identifier: Apache-2.0post
 */


//#include <zephyr.h>
#include  <stdio.h>
#include <string.h>
#include "common.h"
#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>
extern const struct device *gpio0;  
extern const struct device *gpio1;       
extern struct PARAMS PARMS;                                               // has the motor operating mode - 1 = single phase, 2 = two phase
struct STEP {uint8_t m1;
             uint8_t m2;
             uint8_t m3;
             uint8_t m4;} step;
 struct STEP steps[5];
 struct STEP steps2p[]= {{1,0,1,0},{1,0,0,1},{0,1,0,1},{0,1,1,0},{0,0,0,0}};  // dual phase stepping sequence
 struct STEP steps1p[]= {{1,0,0,0},{0,0,0,1},{0,1,0,0},{0,0,1,0},{0,0,0,0}};  // single phase stepping sequence
 void one_step()
 {if(step.m1==1)
    gpio_pin_set(gpio0,PIN_M1,1);
  else gpio_pin_set(gpio0,PIN_M1,0);
  if(step.m2==1)
    gpio_pin_set(gpio0,PIN_M2,1);
  else gpio_pin_set(gpio0,PIN_M2,0);
  if(step.m3==1)
    gpio_pin_set(gpio1,PIN_M3,1);
  else gpio_pin_set(gpio1,PIN_M3,0);
  if(step.m4==1)
    gpio_pin_set(gpio0,PIN_M4,1);
  else gpio_pin_set(gpio0,PIN_M4,0);
 }
void motor_spin(int dir, int times)
{uint32_t i,k;
 for(i=0;i<5;i++)                                                                     // set the stepping sequence for single or dual phase
 {
       if(PARMS.MOTORMODE=='2')
             steps[i]=steps2p[i];
        else steps[i]=steps1p[i];
 }
 
    
 for(k=0;k<times;k++)
    {if(dir==1)                                                                        // if we're spinnint clockise
       {for(i=0;i<4;i++)   //    we go through the st                                  // steps from bottomn to top
          {step=steps[i];
           one_step();
           k_sleep(K_USEC(1200));                                                        // waiting one millisecond betwen each one_step
          }
       }
     if(dir==0)
        {for(i=0;i<4;i++)                                                            // otherwise we go from top to bottom
           {step=steps[3-i];
            one_step();
            k_sleep(K_USEC(1200));
           }
        }

    }
    step=steps[4];                                                                    // reset  to all off
    one_step();
}


