
#include <stdio.h>

#include "uart_async_adapter.h"

//#include <zephyr.h>
#include <zephyr/types.h>
#include  <stdio.h>
#include <string.h>
#include <zephyr/device.h>
#include "common.h"
#include <zephyr/pm/pm.h>
#include <zephyr/pm/device.h>



extern struct device *uart0;
extern struct k_fifo fifo_uart_tx_data;
extern struct k_fifo fifo_uart_rx_data;

static uint8_t rx_buf[200];
static int rx_buf_pos;

static void uart_cb(const struct device *dev, char *user_data)
{

    static uint8_t uart_rx_buff[200];
	static int uart_data_recd,datalen;
	static uint8_t databuf[1100], *buf=databuf,buff2[30],*ptr2,*ptr1;
	struct uart_data_t *zbuf,*ybuf;
    static uint32_t i,j,bytes_to_send,bytes_sent,cnt;
	uint8_t *ptr;

    uart_irq_update(uart0);
	
    if(uart_irq_tx_ready(uart0))
	{
		ybuf=k_fifo_get(&fifo_uart_tx_data,K_NO_WAIT);

		ptr=ybuf->data;
		j=ybuf->len;
		bytes_to_send=j;
		cnt=0;
		while(bytes_to_send>0)
	        {i=uart_fifo_fill(uart0,ptr,bytes_to_send);
             

			 ptr+=i;
			 bytes_to_send-=i;
			 cnt+=i;
			}


		//if(cnt!=j)

		//    printk("CRAP");
		k_free(ybuf);
		uart_irq_tx_disable(uart0);

	}
	
	while(uart_irq_rx_ready(uart0))
		{
		memset(uart_rx_buff,0,sizeof(uart_rx_buff));                                 // clear the buffer
		uart_data_recd=uart_fifo_read(uart0,uart_rx_buff,sizeof(uart_rx_buff));      // read the 
		memmove(buf,uart_rx_buff,uart_data_recd);                                    // move the received characters to the buffer
		buf+=uart_data_recd;                                                         // move the pointer
		*buf=0;                                                                      // and put a NULL at the end
		datalen=buf-databuf;                                                         // find the end of the buffer 
        if(databuf[0]=='\r')                                                         // if the first character in the buffer is a return
			{
				if(datalen>1)                                                        // if there are more that one characters in the buffer
				     memmove(databuf,databuf[1], 999);                               //      shift the buffer left one byte to eliminate the leading return
				buf--;                                                               // and move the pointer
				datalen--;                                                           //     and reduce datalen
				if(datalen==0)                                                       // if the buffer is empty
				    continue;                                                        //     go back to the top of the loop
			}
		if((databuf[datalen-1]=='\r')||(i>800))                                      // if we got a trailing carriage return or more that 800 characters
            {  
				ptr1=databuf;                                                        // we need to eliminate all newlines -   
				ptr2=databuf;                                                        // so we set two pointers to the beginning of the data buffer
				while((ptr1-databuf)<datalen)                                        // look at each character in the databuf
				{
					if(*ptr1!='\n')                                                  // if it isn't a newline
					{
						*ptr2=*ptr1;                                                 // we move it back
						ptr2++;                                                      // and increment the destination pointer
					}
					ptr1++;                                                          // always increment the source pointer
				}
				datalen=ptr2-databuf;                                                // recalcualate the length of the data in the buffer
				if(datalen==1)                                                       // we may have just a return left
				{
					buf=databuf;                                                     // so we reset
					continue;                                                        //    and go back to the top
				}
	            zbuf=k_malloc(sizeof(*zbuf));                                        // otherwise, allocate a fifo entry
   	            zbuf->len=datalen;                                                   //    build the fifo entry
	            memmove(zbuf->data,databuf,datalen);
				k_fifo_put(&fifo_uart_rx_data,zbuf);                                 // put it into the fifo
				buf=databuf;                                                         // reset the pointer into the buff back to the beginning
					  //memset(databuf,0,sizeof(databuf));
		    }
			        
		}

}
void uart_send(char *buf)
{   
    uint32_t i,j;
	struct uart_data_t *uart_send;
	uint8_t buffer[200],*ptr,buffer2[200],buffer3[200];
	memset(buffer,0,sizeof(buffer));
	strcpy(buffer,buf);
    i=strlen(buffer);
	while(true)
	   {
        uart_send=k_malloc(sizeof(*uart_send));
	    if(uart_send==0)
	       {bt_send_data("UART SEND is 0");
		    return;
		   }
		//k_sleep(K_MSEC(100));
	    if(i>sizeof(uart_send->data))
	       {uart_send->len=sizeof(uart_send->data);
		    memmove(uart_send->data,buffer,sizeof(uart_send->data));
	       }
		else {
               uart_send->len=i;
			   memmove(uart_send->data,buffer,i);
			   i=0;
		     }
	    k_fifo_put(&fifo_uart_tx_data,uart_send);




		if(i==0)
		   break;
		memmove(buffer,&buffer[sizeof(uart_send->data)],sizeof(buffer)-sizeof(uart_send->data));
		i=strlen(buffer);
	   }
	 
	 uart_irq_tx_enable(uart0);
	/*
	for(j=0;j<i;j++)
	   uart_poll_out(uart0, buf[j]);
    uart_irq_tx_enable(uart0);
   */
}


uint32_t init_uart(void)
{
	int err;
	struct uart_data_t *rx;
    struct uart_config config;
	uint8_t buff[30];
    uart0 = DEVICE_DT_GET(DT_NODELABEL(uart0)); 
	uart_config_get(uart0, &config);
    config.baudrate=115200;
    config.parity=UART_CFG_PARITY_NONE;
    config.stop_bits= UART_CFG_STOP_BITS_1;
    config.data_bits=UART_CFG_DATA_BITS_8;
    config.flow_ctrl= UART_CFG_FLOW_CTRL_NONE;
	err=uart_configure(uart0, &config);
	uart_irq_callback_user_data_set(uart0, uart_cb,NULL);
    uart_irq_rx_enable(uart0);
    err = pm_device_action_run(uart0, PM_DEVICE_ACTION_SUSPEND);                 // stop UART
	 sprintf(buff,"RET is %d",err);
	 err=0;
    return err;
}

